static const char html_confadv_script[] PROGMEM = R"=====(
<script>
  function g(i) { return document.getElementById(i) };
  function sp(i){g(i).type=(g(i).type==='text'?'password':'text');}
  var xhttp, reqTime, reqFin;
  function setCbx(el, da) {
    if(da == '1') {
      el.checked = true;
      el.style.visibility = 'visible';
    }
    else {
      el.checked = false;
      el.style.visibility = 'visible';
    }
  }
  function updCbxVal(el) {
    if (el.checked) el.value = '1';
    else {
      el.checked = true;
    el.value = '0';
      el.style.visibility = 'hidden';
    }
  }
  
  function transmit(f) {
    if (!xhttp) {   
    reqTime = 0;
    reqFin = false;
    xhttp = new XMLHttpRequest();
    xhttp.timeout = 1000;
    xhttp.overrideMimeType('application/json');
    xhttp.open('POST', 'confdadv');
    xhttp.send(f ? (new FormData(f)) : '');
    xhttp.onreadystatechange = function () {
      if (xhttp.readyState === XMLHttpRequest.DONE && xhttp.status === 200) {
        var data = JSON.parse(xhttp.responseText);
        g('tempDec').value = data.tempDec;
        g('hyst').value = data.hyst;
        g('minOffTime').value = data.minOffTime;
        g('tempCorr').value = data.tempCorr;
        g('humCorr').value = data.humCorr;
        g('offMsg').value = data.offMsg;
        g('itemplab').value = data.itemplab;
        g('otemplab').value = data.otemplab;
        g('modename1').value = data.modename1;
        g('modename0').value = data.modename0;
        g('psetname0').value = data.psetname0;
        g('psetname1').value = data.psetname1;
        g('psetname2').value = data.psetname2;
        xhttp = null;
        reqFin = true;
       }
       else {
         if(!reqFin && reqTime > 10) {
           xhttp = null;
           reqFin = true;
         }
       }
     }
   }
    return false;
  }
  //transmit();
  function saveConf() {
    g('frmConf').submit();
  }
  function init() {
    transmit();
  }
  setInterval(function () { ++reqTime; }, 1000);
</script>
)====="; // html_confadv_script

static const char html_confadv_body[] PROGMEM = R"=====(
<b>Configuration - Thermostat Advanced</b>
<div class='config'>
<form id='frmConf' action='setConfAdv' method='POST'>
<br>
<fieldset>
<legend>Thermostat - Advanced</legend>
<p><b>Hysteresis [°C]</b><br><input type='text' name='hyst' id='hyst'></p><br>

<p><b>Min. Heating Off-Time [s]</b><br><input type='number' name='minOffTime' id='minOffTime'></p>
<p style='font-weight:normal;font-size:0.8em;'>Heating stays off for at least [x] seconds before it <br>can start again.</p><br>

<p><b>Measured Temp Correction [°C] *</b><br><input type='text' name='tempCorr' id='tempCorr'></p>
<p><b>Measured Hum Correction [%] *</b><br><input type='text' name='humCorr' id='humCorr'></p>
<p style='font-weight:normal;font-size:0.8em;'>* added to the measured values. <br>Can be negative and/or fractions. <br>Use if measurements deviate from a calibrated sensor.</p><br>

<p><b>Set Temp. Decrease Value **</b><br><input type='text' name='tempDec' id='tempDec'></p>
<p style='font-weight:normal;font-size:0.8em;'>** the actual set temperatur is decreased by that value.<br>Can be a fraction. Can be used to prevent over-heating <br>when the thermostat is badly placed.<br></p>
</fieldset>
<div></div><br>
<fieldset>
<legend>Names and Labels</legend>
<p style='font-weight:normal;font-size:0.8em;'>Used in some MQTT status/commands, <br>and also for the LCD and Web interface.<br></p><br>
<p><b>Off-Message</b><br><input type='text' name='offMsg' id='offMsg'></p>
<p style='font-weight:normal;font-size:0.8em;'>Shown on LCD in OFF mode. <br><b>max. 13 chars!</b></p>
<br>
<p>Labels</p>
<p style='font-weight:normal;font-size:0.8em;'>Used on LCD to identify the data displayed. <br><b>MUST be 1 char</b> or empty for default</p>
<p><b>Inside</b><br><input type='text' name='itemplab' id='itemplab'/></p>
<p><b>Outside</b><br><input type='text' name='otemplab' id='otemplab'/></p>
<br>
<p>Mode</p>
<p style='font-weight:normal;font-size:0.8em;'>Used in web interface and for Home Assistant <br>MQTT Climate component support. <br>Should be 'heat' and 'off' normally. <br><b>Case sensitive! Lower case recommended.</b><br>Web interface shows all in capitals.</p>
<p><b>On</b><br><input type='text' name='modename1' id='modename1'></p>
<p><b>Off</b><br><input type='text' name='modename0' id='modename0'></p>
<br>
<p>Preset Names</p>
<p style='font-weight:normal;font-size:0.8em;'>Used in web interface and for Home Assistant <br>MQTT Climate component support.<br>
Also shown on LCD at preset change, <br>therefore may not exceed <b>13 chars!</b><br><b>Case sensitive!</b> Type exactly as in HA!</p>
<p><b>Normal *</b><br><input type='text' name='psetname0' id='psetname0'></p>
<p style='font-weight:normal;font-size:0.8em;'>* always sends/receives "<i>none</i>" as this is hardcoded in <br>Home Assistant MQTT Climate component</p>
<p><b>Reduction 1 **</b><br><input type='text' name='psetname1' id='psetname1'></p>
<p><b>Reduction 2 **</b><br><input type='text' name='psetname2' id='psetname2'></p>
<p style='font-weight:normal;font-size:0.8em;'>** sent/received as defined</p>
</fieldset>

<br>
</form>
<div></div>
<table style='width:100%'>
<td style='width:50%'><button onclick='location="conf";' class='bgrey'>Cancel</button></td>
<td style='width:50%'><button onclick='return saveConf()' class='bred'>Save</button></td>
</tr></table>
</div>
)====="; // html_confadv_body
