//extern ESP8266WebServer httpServer;

static const char httpRoot[] PROGMEM =
  R"(<html><body>
  <h1><span id='devname'></span></h1>
  <h3>WiFi Thermostat</h3>
  
  <form id='minusBtnFrm'>
  <input type='hidden' name='minusBtn' value='1'>
  </form>
  <form id='plusBtnFrm'>
  <input type='hidden' name='plusBtn' value='1'>
  </form>
  <form id='pset0BtnFrm'>
  <input type='hidden' name='pset0Btn' value='1'>
  </form>
  <form id='pset1BtnFrm'>
  <input type='hidden' name='pset1Btn' value='1'>
  </form>
  <form id='pset2BtnFrm'>
  <input type='hidden' name='pset2Btn' value='1'>
  </form>
  <form id='onBtnFrm'>
  <input type='hidden' name='onBtn' value='1'>
  </form>
  <form id='offBtnFrm'>
  <input type='hidden' name='offBtn' value='1'>
  </form>
  <span style="font-size:xx-large" id='setTemp'></span> &#8451;<br>
  <input type='button' onclick='return sendMinusBtn()' value='-'/>
  <input type='button' onclick='return sendPlusBtn()' value='+'/><br>
  Curr.setTemp: <span id='currSetTemp'></span><br><br>
  Preset: <span id='pset'></span><br>
  <input id='btnPs0' type='button' onclick='return sendPset0Btn()' value=''/>
  <input id='btnPs1' type='button' onclick='return sendPset1Btn()' value=''/>
  <input id='btnPs2' type='button' onclick='return sendPset2Btn()' value=''/>
  <br>  
  <br>
  Mode: <span id='mode'></span><br>
  <input id='btn_on' type='button' onclick='return sendOnBtn()' value='HEAT'/>
  <input id='btn_off' type='button' onclick='return sendOffBtn()' value='OFF'/><br>
  <br>
  
  Current Temp/Hum: <span id='temp'></span> &#8451;&nbsp;&nbsp;&nbsp;<span id='hum'></span> %<br><br>
  heating currently <span id='heating'></span><br>
  <br>
  WiFi connected to <i><span id='ssid'></span></i>.<br>
  <h6>Last update 
  <span id='ut'></span> seconds ago. 
  <span id='status'></span>
  </h6>
  <br>
  <a href='/wifi.htm'>WiFi settings</a><br>
  <a href='/conf'>Base configuration</a><br>
  <a href='/conf2'>Extended configuration</a><br>
  <a href='/update'>Firmware update</a><br>
  <a href='/restart'>Restart</a>
  <script>
  function g(i) { return document.getElementById(i) };
  var xhttp, updateTime, reqTime, reqFin;
  
  function sendMinusBtn() {
  var form = document.getElementById('minusBtnFrm');
  return transmit(form);
  }
  function sendPlusBtn() {
  var form = document.getElementById('plusBtnFrm');
  return transmit(form);
  }
  function sendPset0Btn() {
  var form = document.getElementById('pset0BtnFrm');
  return transmit(form);
  }
  function sendPset1Btn() {
  var form = document.getElementById('pset1BtnFrm');
  return transmit(form);
  }
  function sendPset2Btn() {
  var form = document.getElementById('pset2BtnFrm');
  return transmit(form);
  }
  function sendOnBtn() {
  var form = document.getElementById('onBtnFrm');
  return transmit(form);
  }
  function sendOffBtn() {
  var form = document.getElementById('offBtnFrm');
  return transmit(form);
  }
  
  function transmit(f) {
    if (!xhttp) { 
      g('status').innerHTML = 'loading...';
   reqTime = 0;
      reqFin = false;
      xhttp = new XMLHttpRequest();
    xhttp.timeout = 2000;
      xhttp.open('POST', 'api');
      xhttp.send(f ? (new FormData(f)) : '');
      xhttp.onreadystatechange = function () {
        if (xhttp.readyState === XMLHttpRequest.DONE && xhttp.status === 200) {
          var data = JSON.parse(xhttp.responseText);
      if(data.devname != undefined) g('devname').innerHTML = data.devname;
          g('temp').innerHTML = data.temp.toFixed(1);
          g('hum').innerHTML = data.hum;
          g('setTemp').innerHTML = data.setTemp.toFixed(1);
          g('ssid').innerHTML = data.ssid;
          g('mode').innerHTML = data.modeName;
          g('pset').innerHTML = data.psetName;
          g('btnPs0').value = data.psetName0;
          g('btnPs1').value = data.psetName1;
          g('btnPs2').value = data.psetName2;
          g('currSetTemp').innerHTML = data.currSetTemp.toFixed(1);
          
          if(data.heating == '1') g('heating').innerHTML = 'ACTIVE';
          else if(data.heating == '0') g('heating').innerHTML = 'NOT ACTIVE';

          xhttp = null;
          g('status').innerHTML = '';
          updateTime = 0;
          reqFin = true;
        }
    else {
    if(!reqFin && reqTime > 10) {
            xhttp = null;
            reqFin = true;
          }
    }
      }
    }
    return false;
  }
  transmit();
  setInterval(function () { g('ut').innerHTML = ++updateTime; ++reqTime; }, 1000);
  setInterval(transmit, 5000);
</script>
  </body></html>)";


static const char httpConfPage[] PROGMEM =
  R"(<html><head><body>
<h3>Base configuration</h3>
<a href='/'>Home</a><br><br>
<input type='button' value='reload' onclick='return transmit()'/><br><br>
<form id='form1' onsubmit='return transmit(this)'>
Device Name: <input type='text' name='devName' id='devName'/><br><br>
HTTP User *: <input type='text' name='httpUser' id='httpUser'/><br>
HTTP Password *: <input type='text' name='httpPass' id='httpPass'/><br><br>
HTTP set token: <input type='text' name='httpToken' id='httpToken'/><br>
MQTT Server *: <input type='text' name='mqttHost' id='mqttHost'/><br>
MQTT Port *: <input type='number' name='mqttPort' id='mqttPort'/><br>
MQTT User *: <input type='text' name='mqttUser' id='mqttUser'/><br>
MQTT Password *: <input type='text' name='mqttPass' id='mqttPass'/><br><br>
In Topic *: <input type='text' name='inTop' id='inTop'/><br>
Out Topic: <input type='text' name='outTop' id='outTop'/><br>
Out Retain *: <input type='checkbox' name='outRet' id='outRet'/><br><br>
LastWill Topic *: <input type='text' name='willTop' id='willTop'/><br>
LastWill Qos *: <select name='willQos' id='willQos'><option>0</option><option>1</option><option>2</option></select><br>
LastWill Retain *: <input type='checkbox' name='willRet' id='willRet'/><br>
LastWill Message *: <input type='text' name='willMsg' id='willMsg'/><br><br>
Connect Message *: <input type='text' name='connMsg' id='connMsg'/><br><br>
Domoticz Out Topic *: <input type='text' name='domOutTop' id='domOutTop'/><br>
<br>
<input type='submit' value='Save'/>
</form>
<form id='restartForm' onsubmit='return res()'>
<input type='hidden' name='restart' value='1'>
<input type='submit' value='Restart'/>
</form>

<script>
 function g(i) { return document.getElementById(i) };
  var xhttp, reqTime, reqFin, rxhttp;
  
  function res() {
    rxhttp = new XMLHttpRequest();
 rxhttp.timeout = 1000;
  rxhttp.open('POST', 'restart');
  rxhttp.send('');
  rxhttp = null;
  return false;
  }
  function setCheckbox(ele, dat) {
    if(dat == 1) {
      ele.checked = true;
      ele.style.visibility = 'visible';
    }
    else {
      ele.checked = false;
      ele.style.visibility = 'visible';
    }
  }
  function updateCheckboxValue(ele) {
    if (ele.checked) ele.value ='1';
    else {
      ele.value = '0';
      ele.checked = true;
      ele.style.visibility = 'hidden';
    }
  }
  
  function transmit(f) {
    if (!xhttp) {   
    reqTime = 0;
    reqFin = false;
    updateCheckboxValue(g('outRet'));
    updateCheckboxValue(g('willRet'));    
    xhttp = new XMLHttpRequest();
    xhttp.timeout = 2000;
    xhttp.open('POST', 'confdata');
    xhttp.send(f ? (new FormData(f)) : '');
    xhttp.onreadystatechange = function () {
      if (xhttp.readyState === XMLHttpRequest.DONE && xhttp.status === 200) {
        var data = JSON.parse(xhttp.responseText);
        g('httpUser').value = data.httpUser;
        g('httpPass').value = data.httpPass;
        g('httpToken').value = data.httpToken;
        g('devName').value = data.devName
        g('mqttHost').value = data.mqttHost;
        g('mqttPort').value = data.mqttPort;
        g('mqttUser').value = data.mqttUser;
        g('mqttPass').value = data.mqttPass;
        g('inTop').value = data.inTop;
        g('outTop').value = data.outTop;
        g('willTop').value = data.willTop;
        g('willQos').value = data.willQos;
        setCheckbox(g('outRet'), data.outRet);
        setCheckbox(g('willRet'), data.willRet);
        g('willMsg').value = data.willMsg;
        g('connMsg').value = data.connMsg;
        g('domOutTop').value = data.domOutTop;
        xhttp = null;
        reqFin = true;
       }
       else {
         if(!reqFin && reqTime > 10) {
           xhttp = null;
           reqFin = true;
         }
       }
     }
   }
    return false;
  }
  transmit();
  setInterval(function () { ++reqTime; }, 1000);
</script>
</body></html>)";



static const char httpConf2Page[] PROGMEM =
  R"(<html><head><body>
<h3>Extended configuration</h3>
<a href='/'>Home</a><br><br>
<input type='button' value='reload' onclick='return transmit()'/><br>
<form id='form1' onsubmit='return transmit(this)'>

<h4>Domoticz</h4>
Idx setTemp: <input type='number' name='domIdxTherm' id='domIdxTherm'/><br>
Idx mode: <input type='number' name='domIdxMode' id='domIdxMode'/><br>
Idx TempHum Sensor: <input type='number' name='domIdxTempHum' id='domIdxTempHum'/><br>
Idx Heating: <input type='number' name='domIdxHeating' id='domIdxHeating'/><br>
Idx PIR: <input type='number' name='domIdxPIR' id='domIdxPIR'/><br>

<h4>Outside Temp/Hum via MQTT</h4>
Temp In-Topic: <input type='text' name='outTempTop' id='outTempTop'/><br>
Hum In-Topic: <input type='text' name='outHumTop' id='outHumTop'/><br>

<h4>Additional MQTT publish topics</h4>
PIR sensor: <input type='text' name='PIRTop' id='PIRTop'/><br>

<h4>Auto-Save</h4>
setTemp: <input type='checkbox' name='autoSaveTemp' id='autoSaveTemp'/><br>
mode/preset: <input type='checkbox' name='autoSaveMode' id='autoSaveMode'/><br>

<h4>Thermostat / Heating</h4>
Min. Off-Time: <input type='number' name='minOffTime' id='minOffTime'/><br>
Min. Temp: <input type='text' name='tempMin' id='tempMin'/><br>
Max. Temp: <input type='text' name='tempMax' id='tempMax'/><br>
Reduction Mode Temp: <input type='text' name='tempLow' id='tempLow'/><br>
Reduction Mode 2 Temp: <input type='text' name='tempLow2' id='tempLow2'/><br>
set temp decrease value: <input type='text' name='tempDec' id='tempDec'/><br>
Hysteresis: <input type='text' name='hyst' id='hyst'/><br>
Temp Correction.: <input type='text' name='tempCorr' id='tempCorr'/><br>
Hum Correction: <input type='number' name='humCorr' id='humCorr'/><br>

<h4>Intervals / Timeouts</h4>
Measure Interval: <input type='number' name='measInt' id='measInt'/><br>
Display Interval: <input type='number' name='dispInt' id='dispInt'/><br>
Display Timeout: <input type='number' name='dispTout' id='dispTout'/><br>

<h4>Names</h4>
used in MQTT status/commands and HTTP interface<br>
max. 13 chars!<br>
Off-Message: <input type='text' name='offMsg' id='offMsg'/><br>
<h5>Temp Labels</h5>
Inside: <input type='text' name='itemplab' id='itemplab'/><br>
Outside: <input type='text' name='otemplab' id='otemplab'/><br>
* 1 char
<h5>Mode</h5>
Off: <input type='text' name='modename0' id='modename0'/><br>
On: <input type='text' name='modename1' id='modename1'/><br>
<br>
<h5>Presets:</h5>
Normal*: <input type='text' name='psetname0' id='psetname0'/><br>
Reduction 1: <input type='text' name='psetname1' id='psetname1'/><br>
Reduction 2: <input type='text' name='psetname2' id='psetname2'/><br>
* will always send/receive "none" as hardcoded in Home Assistant.

<h4>Misc</h4>
PIR enables Display: <input type='checkbox' name='PIRenDisp' id='PIRenDisp'/><br>
toggling I/A-Temp and Hum display*: <input type='checkbox' name='togTHdisp' id='togTHdisp'/><br>
* otherwise fixed I/A-Temp<br>
<br><br>
<input type='submit' value='Save'/>
</form>
<form id='rebootForm' onsubmit='return res()'>
<input type='submit' value='Restart'/>
</form>

<script>
 function g(i) { return document.getElementById(i) };
  var xhttp, reqTime, reqFin, rxhttp;
  
  function res() {
    rxhttp = new XMLHttpRequest();
 rxhttp.timeout = 1000;
  rxhttp.open('POST', 'restart');
  rxhttp.send('');
  rxhttp = null;
  return false;
  }
  function setCheckbox(ele, dat) {
    if(dat == 1) {
      ele.checked = true;
      ele.style.visibility = 'visible';
    }
    else {
      ele.checked = false;
      ele.style.visibility = 'visible';
    }
  }
  function updateCheckboxValue(ele) {
    if (ele.checked) ele.value ='1';
    else {
      ele.value = '0';
      ele.checked = true;
      ele.style.visibility = 'hidden';
    }
  }

  function transmit(f) {
    if (!xhttp) {
      updateCheckboxValue(g('autoSaveTemp'));
      updateCheckboxValue(g('autoSaveMode'));
   updateCheckboxValue(g('PIRenDisp'));
      xhttp = new XMLHttpRequest();
      xhttp.timeout = 2000;
      xhttp.open('POST', 'confdata2');
      xhttp.send(f ? (new FormData(f)) : '');
      xhttp.onreadystatechange = function () {
        if (xhttp.readyState === XMLHttpRequest.DONE && xhttp.status === 200) {
          var data = JSON.parse(xhttp.responseText);
          setCheckbox(g('autoSaveTemp'), data.autoSaveTemp);
          setCheckbox(g('autoSaveMode'), data.autoSaveMode);
          setCheckbox(g('PIRenDisp'), data.PIRenDisp);
          setCheckbox(g('togTHdisp'), data.togTHdisp);
          g('domIdxTherm').value = data.domIdxTherm;
          g('domIdxMode').value = data.domIdxMode;
          g('domIdxTempHum').value = data.domIdxTempHum;
          g('domIdxHeating').value = data.domIdxHeating;
          g('domIdxPIR').value = data.domIdxPIR;
          g('outTempTop').value = data.outTempTop;
          g('outHumTop').value = data.outHumTop;
          g('PIRTop').value = data.PIRTop;
          g('minOffTime').value = data.minOffTime;
          g('tempMin').value = data.tempMin;
          g('tempMax').value = data.tempMax;
          g('tempLow').value = data.tempLow;
          g('tempLow2').value = data.tempLow2;
          g('tempDec').value = data.tempDec;
          g('hyst').value = data.hyst;
          g('tempCorr').value = data.tempCorr;
          g('humCorr').value = data.humCorr;
          g('measInt').value = data.measInt;
          g('dispInt').value = data.dispInt;
          g('dispTout').value = data.dispTout;
          g('offMsg').value = data.offMsg;
          g('modename0').value = data.modename0;
          g('modename1').value = data.modename1;
          g('psetname0').value = data.psetname0;
          g('psetname1').value = data.psetname1;          
          g('psetname2').value = data.psetname2;
          g('itemplab').value = data.itemplab;
          g('otemplab').value = data.otemplab;
          
          xhttp = null;
          reqFin = false;
        }
      else {
          if(!reqFin && reqTime > 10) {
            xhttp = null;
            reqFin = true;
          }
       }
    }
    }
    return false;
  }
  transmit();
  setInterval(function () { ++reqTime; }, 1000);
</script>
</body></html>)";

void httpServerHandleRoot() {
  httpServer.send_P(200, "text/html", httpRoot);
}

void httpServerHandleConfPage() {
  httpServer.send_P(200, "text/html", httpConfPage);
}

void httpServerHandleConf2Page() {
  httpServer.send_P(200, "text/html", httpConf2Page);
}

//void httpServerHandleNotFound() {
//  String message = "File Not Found\n\n";
//  message += "URI: ";
//  message += httpServer.uri();
//  message += "\nMethod: ";
//  message += (httpServer.method() == HTTP_GET) ? "GET" : "POST";
//  message += "\nArguments: ";
//  message += httpServer.args();
//  message += "\n";
//  for (uint8_t i = 0; i < httpServer.args(); i++) {
//    message += " " + httpServer.argName(i) + ": " + httpServer.arg(i) + "\n";
//  }
//  httpServer.send(404, "text / plain", message);
//}

void httpServerHandleNotFound() {
  //  if (strlen(http_user) > 0 && strlen(http_pass) > 0) {
  //    if (!httpServer.authenticate(http_user, http_pass))
  //      return httpServer.requestAuthentication();
  httpServer.send(404, "text/plain", "");
  //}
}

void httpServerInit() {
  httpServer.on("/delconf", []() {
    Serial.println("httpServer.on /delconf");
    if (httpServer.hasArg("token")) {
      char buf[20];
      httpServer.arg("token").toCharArray(buf, 20);
      if (strcmp(buf, CLEARCONF_TOKEN) == 0) {
        //        httpServer.send(200, "text / plain", "Token OK - deleting config");
        deleteConfig();
      }
    } //if
    //    else {
    //      httpServer.send(200, "text / plain", "not allowed");
    //    }
  });

  httpServer.on("/api", []() {
    boolean isAuthenticated = false;
    if (strlen(http_user) > 0 && strlen(http_pass) > 0) {
      if (!httpServer.authenticate(http_user, http_pass)) return httpServer.requestAuthentication();
      isAuthenticated = true;
    }
    else isAuthenticated = true;
    if (isAuthenticated) {
      DEBUG_PRINT("httpServer.on /api");
      if (httpServer.hasArg("plusBtn")) {
        setTempStepUp();
        DEBUG_PRINT(P("web plusBtn"));
      } //if
      if (httpServer.hasArg("minusBtn")) {
        setTempStepDown();
        DEBUG_PRINT(P("web minusBtn"));
      } //if
      if (httpServer.hasArg("pset0Btn")) {
        setPresetTo(0);
        DEBUG_PRINT(P("web pset0Btn"));
      } //if
      if (httpServer.hasArg("pset1Btn")) {
        setPresetTo(1);
        DEBUG_PRINT(P("web pset1Btn"));
      } //if
      if (httpServer.hasArg("pset2Btn")) {
        setPresetTo(2);
        DEBUG_PRINT(P("web pset2Btn"));
      } //if
      if (httpServer.hasArg("onBtn")) {
        setHeatingmodeTo(1);
        DEBUG_PRINT(P("web onBtn"));
      } //if
      if (httpServer.hasArg("offBtn")) {
        setHeatingmodeTo(0);
        DEBUG_PRINT(P("web offBtn"));
      } //if

      //char ch_currTemp[6];
      //char ch_currSetTemp[6];
      //dtostrf(currTemp, 1, 1, ch_currTemp );
      //dtostrf(setTemp, 1, 1, ch_currSetTemp );

      //build json object of program data
      StaticJsonBuffer<400> jsonBuffer;
      JsonObject &json = jsonBuffer.createObject();
      json["devname"] = deviceName;
      json["ssid"] = WiFi.SSID();
      json["setTemp"] = setTemp;
      json["currSetTemp"] = currSetTemp;
      json["temp"] = currTemp;
      json["hum"] = int(currHum);
      json["heating"] = turnHeatingOn;
      json["mode"] = heatingMode;
      json["modeName"] = currentModeName;
      json["pset"] = preset;
      json["psetName"] = currentPresetName;
      json["psetName0"] = psetname0;
      json["psetName1"] = psetname1;
      json["psetName2"] = psetname2;

      char jsonchar[400];
      json.printTo(jsonchar); //print to char array, takes more memory but sends in one piece
      httpServer.send(200, "application/json", jsonchar);
    }
    else {
      httpServer.send (401, "text/plain", "UNAUTHORIZED");
    }
  }); //httpServer.on /api

  httpServer.on("/restart", []() {
    if (httpServer.hasArg("token")) {
      Serial.println("web triggered restart");
      ESP.restart();
    }
    else {
      httpServer.send (403, "text/plain", "FORBIDDEN");
    }
  });

  httpServer.on("/mqttReconnect", []() {
    if (httpServer.hasArg("token")) {
      Serial.println("web triggered mqttReconnect");
      mqttReconnect();
      httpServer.sendHeader("Location", String("/"), true);
      httpServer.send (302, "text/plain", "OK");
    }
    else {
      httpServer.send (403, "text/plain", "FORBIDDEN");
    }
  });

  httpServer.on("/setPoint", []() {
    if (httpServer.hasArg("token")) {
      char buf[20];
      httpServer.arg("token").toCharArray(buf, 20);
      if (strcmp(buf, http_token) == 0) {
        Serial.println("web triggered setPoint");
        if (httpServer.hasArg("value")) {
          char bufVal[20];
          httpServer.arg("value").toCharArray(bufVal, 20);
          float valueFloat = round(atof(bufVal) * 2.0) / 2.0;
          setTempTo(valueFloat);
          httpServer.send (200, "text/plain", "OK");
        }
      }
    } //if
    else {
      httpServer.send (403, "text/plain", "FORBIDDEN");
    }
  });

  httpServer.on("/setMode", []() {
    if (httpServer.hasArg("token")) {
      char buf[20];
      httpServer.arg("token").toCharArray(buf, 20);
      if (strcmp(buf, http_token) == 0) {
        Serial.println("web triggered setMode");
        if (httpServer.hasArg("value")) {
          char bufVal[20];
          httpServer.arg("value").toCharArray(bufVal, 20);
          int valueInt = atoi(bufVal);
          if (valueInt >= 0 && valueInt <= 1) setHeatingmodeTo(valueInt);
          httpServer.send (200, "text/plain", "OK");
        }
      }
    } //if
    else {
      httpServer.send (403, "text/plain", "FORBIDDEN");
    }
  });

  httpServer.on("/setPreset", []() {
    if (httpServer.hasArg("token")) {
      char buf[20];
      httpServer.arg("token").toCharArray(buf, 20);
      if (strcmp(buf, http_token) == 0) {
        Serial.println("web triggered setPreset");
        if (httpServer.hasArg("value")) {
          char bufVal[20];
          httpServer.arg("value").toCharArray(bufVal, 20);
          int valueInt = atoi(bufVal);
          if (valueInt >= 0 && valueInt <= 2) setPresetTo(valueInt);
          httpServer.send (200, "text/plain", "OK");
        }
      }
    } //if
    else {
      httpServer.send (403, "text/plain", "FORBIDDEN");
    }
  });

  httpServer.on("/confdata", []() {
    boolean isAuthenticated = false;
    if (strlen(http_user) > 0 && strlen(http_pass) > 0) {
      if (!httpServer.authenticate(http_user, http_pass)) return httpServer.requestAuthentication();
      isAuthenticated = true;
    }
    else isAuthenticated = true;
    if (isAuthenticated) {
      Serial.println("httpServer.on /confdata");

      for (int i = 0; i < httpServer.args(); i++) {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0) {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);
          setConfig(bufName, bufValue);
        }
        saveConfigToFlash = true; // will be saved in next loop()
        Serial.println("web triggered saveConfigToFlash");
      }
      yield();

      //build json object of program data
      StaticJsonBuffer<1000> jsonBuffer;
      JsonObject &json = jsonBuffer.createObject();
      json["devName"] = deviceName;
      json["httpUser"] =  http_user;
      json["httpPass"] =  http_pass;
      json["httpToken"] =  http_token;
      json["mqttHost"] = mqtt_server;
      json["mqttPort"] = mqtt_port;
      json["mqttUser"] =  mqtt_user;
      json["mqttPass"] =  mqtt_pass;
      json["inTop"] = mqtt_topic_in;
      json["outTop"] = mqtt_topic_out;
      json["outRet"] = mqtt_outRetain;
      json["willTop"] = mqtt_willTopic;
      json["willQos"] = mqtt_willQos;
      json["willRet"] = mqtt_willRetain;
      json["willMsg"] = mqtt_willMsg;
      json["connMsg"] = mqtt_connMsg;
      json["domOutTop"] = domoticz_out_topic;

      yield();

      char jsonchar[1000];
      json.printTo(jsonchar); //print to char array, takes more memory but sends in one piece
      httpServer.send(200, "application/json", jsonchar);
    }
    else {
      httpServer.send (401, "text/plain", "UNAUTHORIZED");
    }
  }); //httpServer.on /confdata

  httpServer.on("/confdata2", []() {
    boolean isAuthenticated = false;
    if (strlen(http_user) > 0 && strlen(http_pass) > 0) {
      if (!httpServer.authenticate(http_user, http_pass)) return httpServer.requestAuthentication();
      isAuthenticated = true;
    }
    else isAuthenticated = true;
    if (isAuthenticated) {
      Serial.println("httpServer.on /confdata2");

      for (int i = 0; i < httpServer.args(); i++) {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0) {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);
          setConfig(bufName, bufValue);
        }
        saveConfig2ToFlash = true;
        Serial.println("web triggered saveConfig2ToFlash");
      }
      yield();

      //build json object of program data
      StaticJsonBuffer<1000> jsonBuffer;
      JsonObject &json = jsonBuffer.createObject();

      json["domIdxTherm"] = domoticzIdx_Thermostat;
      json["domIdxMode"] = domoticzIdx_ThermostatMode;
      json["domIdxTempHum"] = domoticzIdx_TempHumSensor;
      json["domIdxHeating"] = domoticzIdx_Heating;
      json["domIdxPIR"] = domoticzIdx_PIR;
      json["outTempTop"] = outTemp_topic_in;
      json["outHumTop"] = outHum_topic_in;
      json["PIRTop"] = mqtt_topic_pir;
      json["autoSaveTemp"] = autoSaveSetTemp;
      json["autoSaveMode"] = autoSaveHeatingMode;
      json["minOffTime"] = heatingMinOffTime;
      json["tempMin"] = setTempMin;
      json["tempMax"] = setTempMax;
      json["tempLow"] = setTempLow;
      json["tempLow2"] = setTempLow2;
      json["tempDec"] = setTempDecreaseVal;
      json["hyst"] = hysteresis;
      json["tempCorr"] = tempCorrVal;
      json["humCorr"] = humCorrVal;
      json["measInt"] = measureInterval;
      json["dispInt"] = displayInterval;
      json["dispTout"] = displayTimeout;
      json["offMsg"] = offMessage;
      json["modename0"] = modename0;
      json["modename1"] = modename1;
      json["psetname0"] = psetname0;
      json["psetname1"] = psetname1;
      json["psetname2"] = psetname2;
      json["itemplab"] = itemplab;
      json["otemplab"] = otemplab;
      json["PIRenDisp"] = PIR_enablesDisplay;
      json["togTHdisp"] = togglingTempHumAIDisplay;

      yield();

      char jsonchar[1000];
      json.printTo(jsonchar); //print to char array, takes more memory but sends in one piece
      httpServer.send(200, "application/json", jsonchar);
    }
    else {
      httpServer.send (401, "text/plain", "UNAUTHORIZED");
    }
  }); //httpServer.on /confdata2




  //get heap status, analog input value and all GPIO statuses in one json call
  httpServer.on("/info", HTTP_GET, []() {
    boolean isAuthenticated = false;
    if (strlen(http_user) > 0 && strlen(http_pass) > 0) {
      if (!httpServer.authenticate(http_user, http_pass)) return httpServer.requestAuthentication();
      isAuthenticated = true;
    }
    else isAuthenticated = true;
    if (isAuthenticated) {
      String json = " {";
      json += "\"wifissid\":\"" + WiFi.SSID() + "\"";
      json += "\"heap\":" + String(ESP.getFreeHeap());
      json += "}";
      httpServer.send(200, "text/json", json);
      json = String();
    }
    else {
      httpServer.send (401, "text/plain", "UNAUTHORIZED");
    }
  }); //httpServer.on /info

  httpServer.on("/", []() {
    boolean isAuthenticated = false;
    if (strlen(http_user) > 0 && strlen(http_pass) > 0) {
      if (!httpServer.authenticate(http_user, http_pass)) return httpServer.requestAuthentication();
      isAuthenticated = true;
    }
    else isAuthenticated = true;
    if (isAuthenticated) {
      httpServerHandleRoot();
    }
    else {
      httpServer.send (401, "text/plain", "UNAUTHORIZED");
    }
  });

  httpServer.on("/conf", []() {
    boolean isAuthenticated = false;
    if (strlen(http_user) > 0 && strlen(http_pass) > 0) {
      if (!httpServer.authenticate(http_user, http_pass)) return httpServer.requestAuthentication();
      isAuthenticated = true;
    }
    else isAuthenticated = true;
    if (isAuthenticated) {
      httpServerHandleConfPage();
    }
    else {
      httpServer.send (401, "text/plain", "UNAUTHORIZED");
    }
  });

  httpServer.on("/conf2", []() {
    boolean isAuthenticated = false;
    if (strlen(http_user) > 0 && strlen(http_pass) > 0) {
      if (!httpServer.authenticate(http_user, http_pass)) return httpServer.requestAuthentication();
      isAuthenticated = true;
    }
    else isAuthenticated = true;
    if (isAuthenticated) {
      httpServerHandleConf2Page();
    }
    else {
      httpServer.send (401, "text/plain", "UNAUTHORIZED");
    }
  });

  httpServer.onNotFound([]() {
    httpServerHandleNotFound();
  }); //httpServer.onNotFound

  // HTTP Updater at /update
  httpUpdater.setup(&httpServer);

  httpServer.begin();
}
