# WiFiThermostat - Commands

## Valid Commands

All commands can be used via Serial, MQTT (/cmd topic) and Web Console.  

| Command             | Description 
| ------------------- | ---------------------------------------------------
| sysinfo             | show uptime, free heap, heap fragmentation...
| date                | show current date/time
| syncclock           | perform NTP time sync now
| debugmode [0/1]     | enable/disable debug mode  <br> currently only prints sysinfo every second but will be enhanced in the near future
| loadconf            | load saved configuration as it´s done on every startup
| getconf             | list all conf parameters  <br> Parameters are displayed in format "CATEGORY.PARAM: VALUE", each on one line.  <br> Use PARAM name in set/get commands.  <br> Use CATEGORY in get command to display all related parameters.  
| get [PARAM]         | show a named conf value  
| get [CATEGORY]      | lists conf values of one category  
| get values          | list all current saved values (see table below)
| set [PARAM] [VALUE] | sets PARAM to VALUE  <br> (add 1 blank after PARAM to clear)
| saveconf            | save all configurations  <br> mandatory as last step before restarting when configuring via commands
| savevalues          | save set values
| clearcreds          | delete all passwords  ***
| clearwifi           | delete WiFi configurations    ****
| mqttinfo            | show MQTT connection info
| mqttreset           | reset MQTT connection and reconnect
| encrypt             | switch on encrypted stored passwords
| decrypt             | switch off encrypted stored passwords  <br> WARNING: deletes all currently saved credentials ****
| ls                  | list files on SPIFFS
| delconf             | delete ALL configuration  ****
| restart             | 

*** only affects MQTT and Web passwords, WiFi passwords are not touched.  

**** You will have to enter WiFi credentials again. __BEFORE RESTART__ this can be done via command or Web Interface.  After restarting with cleared configuration you cannot access the device over WiFi any more. Therefore reconfiguration can only be done via AP-Mode/Captive Portal or Serial Console afterwards!  

## Configuration Categories

For use with command "get" only.  
Case-Insensitive.  

| Category    | Description
| ----------- | --------------------
| confDevWiFi | Device and WiFi configuration
| confDev     | alias for 'confdevwifi'
| confWiFi    | alias for 'confdevwifi'
| confWeb     | Web Interface configuration
| confMqtt    | MQTT configuration
| confBas     | Thermostat Basic configuration
| confAdv     | Thermostat Advanced configuration
| confAdd     | Additional Functions configuration
| confTime    | configuration regarding Time and NTP
| confLog     | configuration regarding Logging


