## Libraries

### ESP8266 core for Arduino
https://github.com/esp8266/Arduino  
* includes:  
    * ESP8266WiFi.h  
    * WiFiClient.h  
    * ESP8266WebServer.h  
    * ESP8266mDNS.h  
    * ESP8266HTTPUpdateServer.h  
    * DNSServer.h  
    * FS.h (SPIFFS)  
    * Wire.h (I2C library)  
* used versions:  
    * from v0.4.0:  
      Core 2.6.3
	* pre v0.4.0:  
	  Core 2.4.0-beta2  
	  because final 2.4.0 release had connection bugs and older v2.3.0 was stable but had some serious security holes

### ArduinoJson
installed from library manager
* from v0.4.0:  
  ArduinoJson 6.13.0  
  which includes breaking changes and needed code updates but is simpler to use and needs less memory  
* pre v0.4.0:  
  ArduinoJson 5.13.0  

### Adafruit DHT-sensor-library
https://github.com/adafruit/DHT-sensor-library  
Examples include both a "standalone" DHT example and one that works along with the Adafruit Unified Sensor Library. A Unified sensor library is required even if using the standalone version.  
Used the "standalone" version for reading the DHT22 sensor. 

* from v0.4.0:  
  DHT-sensor-library-1.3.8  
* from v0.3.3:  
  DHT-sensor-library-1.3.7  
  because v1.3.0 had issues (error reading sensor very often)  
* pre v0.3.3:  
  DHT-sensor-library-1.3.0  

### Adafruit Unified Sensor Driver
dependency of Adafruit DHT-sensor-library, has to be installed to compile sucessfully although not really used for the "standalone" DHT library.  
https://github.com/adafruit/Adafruit_Sensor  
* from v0.4.0:  
  Adafruit Unified Sensor 1.1.1  
  +dependency Adafruit ADXL343, whatever  
* pre v0.4.0:  
  Adafruit Unified Sensor 1.0.2  

### PersWiFiManager(Ext)
AP with captive portal for initial (WiFi-) configuration.  
Used with modification - added #define WIFI_HTM_PROGMEM to PersWiFiManager.cpp (turns off SPIFFS usage and stores HTML page to PROGMEM to simplify firmware upload)  
https://github.com/r-downing/PersWiFiManager

* from v0.5.0:  
  PersWiFiManagerExt v1.0.0 which is my own fork of r-downing´s PersWiFiManager v5.0.0
* from v0.4.0:  
  PersWiFiManager v5.0.0
* pre v0.4.0:  
  PersWiFiManager v3.0.1

### knolleary PubSubClient
MQTT client for Arduino  
https://github.com/knolleary/pubsubclient  
https://pubsubclient.knolleary.net/  

* from v0.4.0:  
  PubSubClient v2.7  
  used without modifications due to dropped Domoticz support
* pre v0.4.0:  
  PubSubClient v2.7  
  used with the following modified DEFINEs in PubSubClient.h:  
  MQTT_MAX_PACKET_SIZE: increased to 512, needed for receiving/parsing domoticz/out topic

### LiquidCrystal I2C 
* from v0.4.0:  
  LiquidCrystal_I2C v1.1.3 from here:  
  https://github.com/johnrickman/LiquidCrystal_I2C/releases

* pre v0.4.0: commit e3701fb 2017-03-09 from here:  
  https://github.com/fdebrabander/Arduino-LiquidCrystal-I2C-library

### r89m Button + PushButton
Button handling library with callbacks on press, release, hold, hold-repeat.  
PushButton.h extends Button.h.  
https://github.com/r89m/PushButton  
https://github.com/r89m/Button  

- PushButton v1.0.0  
- Button v2.0.1 (from v0.4.0, v2.0.0 before)

### Bounce2
used by r89m Button/PushButton.  
https://github.com/thomasfredericks/Bounce2  

* from v0.4.0:  
  Bounce2 2.52
* pre v0.4.0:  
  Bounce2 2.41  

### arduinoWebSockets 2.1.4
for experimental Web console  
https://github.com/Links2004/arduinoWebSockets  

* from v0.6.0

