# WiFiThermostat

ESP8266 based, WiFi connected thermostat designed as replacement for electronic room thermostats used for most domestic heating systems. 

[Deutsche version](./README_DE.md)

## Features
* current temperature/humidity measurement using a digital DHT22 type sensor
* smoothing of measured values, filtering of 
* thermostat with configurable hysteresis and 3 modes with different set-point temperatures (normal, 2x reduction)
* control unit with LCD and 3 pushbuttons
* power unit with power supply and relais for heating control
* telemetry via WiFi/MQTT (set temp, heating mode, heating on/off, PIR-sensor)
* web interface for configuration and control
* configuration and value changes also via MQTT and UART commands
* PIR movement sensor for room surveillance can be attached, status is pushed via MQTT
* initial configuration via WiFi AP mode with captive portal
* non blocking WiFi and MQTT connection
* built-in support for Home Assistant home automation server via MQTT, supports:
	* set heating target temperature
	* set heating mode
	* local or webIF changes sends updates to HASS
	* current temperature/humidity is reported
	* PIR sensor state changes (if connected) are reported
* built-in 2-way support for [Domoticz](https://domoticz.com/) Home Automation controller over MQTT
	* set point and mode can be controlled from Domoticz
	* local changes sending updates to Domoticz
	* current temperature/humidity is reported to Domoticz
	* PIR sensor state changes (if connected) are pushed to Domoticz
	* designed to use Domoticz as the "intelligent" controller for schedules etc.
	* NOW NOT UNDER ACTIVE DEVELOPMENT ANY MORE as I switched to Home Assistant
* value changes (set point and mode, both from local and remote) can be automatically saved to flash

## Hardware

### Control Unit
To be installed instead of normal room thermostat. Uses 3 wires directly connected with Power Unit (+5V, GND, HEATING).

consists of: 
* small wall mount case
* 2x16 char LCD display
* 3 buttons (plus, minus, mode)
* DHT22 temperature/humidity sensor
* ESP8266 MCU (Wemos D1 mini)
* transistor for relay

### Power Unit
To be installed near or inside the actual heating. 
Power supply must be connected to power (230V), heating relay (2 wires) connects to room thermostat terminals on the heating controller. 
Supports all 5-240V AC/DC (but requires extra relay to switch high loads such as an electric heating!).

consists of: 
* power supply module (5V/3W)
* 5V close-circuit relay for heating control

## Software
[Libraries](./LIBRARIES.md)



## Web Interface

Screenshots here: [Web Interface](./WEBINTERFACE.md)

