# Software

## Libraries

### ESP8266 core for Arduino 2.4.0 beta2 (as 2.4 release has connection bugs)
* ESP8266WiFi.h
* WiFiClient.h
* ESP8266WebServer.h
* ESP8266mDNS.h
* ESP8266HTTPUpdateServer.h
* DNSServer.h
* FS.h (SPIFFS)
* Wire.h (I2C library)

https://github.com/esp8266/Arduino

### ArduinoJson 5.13.0
from library manager

### Adafruit DHT-sensor-library (DHT.h)
Used unmodified for reading the DHT22 sensor. 

https://github.com/adafruit/DHT-sensor-library

### Adafruit Sensor 1.0.2
Not really used, but has to be installed when using Adafruit DHT-sensor-library (even if I dont use the DHT_U.h version included in this lib, but gives compile error if not installed).

https://github.com/adafruit/Adafruit_Sensor

### r-downing PersWiFiManager 3.0.1
AP with captive portal for initial (WiFi-) configuration. 
Used with modification - added #define WIFI_HTM_PROGMEM to PersWiFiManager.cpp (turns off SPIFFS usage and stores HTML page to PROGMEM)

https://github.com/r-downing/PersWiFiManager

### knolleary PubSubClient 2.7
MQTT client for Arduino. Used with the following modified DEFINEs in PubSubClient.h: 
* MQTT_MAX_PACKET_SIZE: increased to 512, needed for receiving/parsing domoticz/out topic

https://github.com/knolleary/pubsubclient

https://pubsubclient.knolleary.net/

### LiquidCrystal I2C (commit e3701fb, Mar 9 2017)

https://github.com/fdebrabander/Arduino-LiquidCrystal-I2C-library

### r89m Button + PushButton
Button handling library with callbacks on press, release, hold, hold-repeat.
PushButton.h extends Button.h.

https://github.com/r89m/PushButton

https://github.com/r89m/Button

### Bounce2
used by r89m Button/PushButton.

https://github.com/thomasfredericks/Bounce2



[Hauptseite](./README_DE.md)